#Anzeige des TD40-Zeichensatzes
#vp070712
$infile = 'm506-td40.bin';

open IN, "<$infile";
binmode IN;

seek IN, 0x02BE, 0;

$char = 32;

until (eof IN) {
	read IN, $row, 6;
	printchar ($row);
	$char++;
	#last if $ln++ > 4;
}

close IN;

sub printchar {
	my $code=shift;
	
	printf "; Char %.2X %s\n", $char, $char < 32?'':"(".chr($char).")";

	my @bytes = unpack "B8"x6, $code;
#	print "@bytes\n";
	
	# Transponieren
	my @tbytes;
	for ($i=0; $i<8; $i++) {
		for ($j=0; $j<8; $j++) {
			$tbytes[$i] .= substr($bytes[$j],$i,1);
		}
	}
	
	#print "$code - @bytes\n";
	
#	foreach (@tbytes) {
	foreach (@bytes) {
		print "\tDB\t${_}B\t;";
		tr/01/ #/;
		print qq("$_"\n);
	}
	print "\n";
}
