#!/usr/bin/perl
# vp 09.06.2008, einfaches PRG zum Erzeugen der Offset-Tabelle
# das Programm mu 2x auf verschiedenen Adressen generiert worden sein!

# Liste fpr treiber.asm erstellen:
# 188h Byte = 488h-300h = START-BEG
#genoffstab.pl treiber1_0300.bin treiber1_0400.bin 0188

open FILE1, $ARGV[0] or die;
binmode FILE1;

open FILE2, $ARGV[1] or die;
binmode FILE2;

$ende = (oct '0x'.$ARGV[2]) || 0xFFFF;
# printf "ende: %.4X\n", $ende;	

$bufsize1 = $bufsize2 = 0x10; 
$offset = 0;

while ($bufsize1>0) {
	$bufsize1 = sysread(FILE1, $buf1, $bufsize1); 
	$bufsize2 = sysread(FILE2, $buf2, $bufsize2); 

	for ($i=0;$i<$bufsize1;$i++) {
		$byte1 = ord(substr($buf1,$i,1));
		$byte2 = ord(substr($buf2,$i,1));
		$diff = $byte1 - $byte2;
		
		if ($i+$offset > $ende) { 
			last;
		}

		if ($diff != 0) {
			#printf "%.4X\tdb\t%.2Xh\n", $i+$offset, $i+$offset-$last_i;	
			
			if ($i+$offset-$last_i > 255) {
				printf "ERROR: Adr. %.4X Distanz %.4X zu gro!\n",$i+$offset, $i+$offset-$last_i;
			}
			
			printf "\tdb\t%.2Xh\n", $i+$offset-$last_i;	
			$last_i = $i+$offset;
		}
	}
	$offset += $bufsize1;
}
printf "\tdb\t%.2Xh\n", 0;	

close FILE1;
close FILE2;
